<script lang="ts">
  import {
    ActionMode,
    createActionDispatcher,
    isActivePlayer,
  } from "./actionUtils";
  import Actions from "./components/Actions.svelte";
  import CardBack from "./components/CardBack.svelte";
  import CardFront from "./components/CardFront.svelte";
  import Deck from "./components/Deck.svelte";
  import EmptyCardSpot from "./components/EmptyCardSpot.svelte";
  import Hint from "./components/icons/Hint.svelte";
  import Life from "./components/icons/Life.svelte";
  import LatestAction from "./components/LatestAction.svelte";
  import { suits } from "./serverUtils";
  import { cardsBySuit, orderPlayers, reversed } from "./util";

  const dispatchAction = createActionDispatcher();

  export let playerId: PlayerId | null;
  export let state: GameState;
  // export let settings: GameSettings;

  $: players = orderPlayers(state.players, playerId);

  let user: Player | null;
  $: user = state.players.find((p) => p.id === playerId) ?? null;

  let actionMode: ActionMode | null = null;
  $: {
    actionMode = null && state && playerId; // set actionMode to null when state or userId changes
  }

  function handleChangeMode(event: CustomEvent<ActionMode | null>) {
    actionMode = event.detail;
  }

  function isSpeaking(state: GameState, playerId: PlayerId): boolean {
    return state.latest?.[1]?.player === playerId;
  }

  $: playedCards = cardsBySuit(state.played);
  $: discardedCards = cardsBySuit(state.discarded);

  function showCardFaces({
    player,
    user,
  }: {
    player: Player;
    user: Player | null;
  }): boolean {
    return !!user && user.id !== player.id;
  }
</script>

<main>
  <section class="center" class:user>
    <div class="cards-field">
      <h4>Played cards</h4>
      <ul class="played">
        {#each suits as suit (suit)}
          <li class="played-card">
            <div class="played-card-spot">
              <EmptyCardSpot />
            </div>
            {#if playedCards[suit]}
              <Deck deck={playedCards[suit]} />
            {/if}
          </li>
        {/each}
      </ul>
    </div>

    <div class="counters">
      <ul class="lives" aria-label="{state.lives} lives remaining.">
        {#each [1, 2, 3] as life}
          <Life lost={state.lives < life} />
        {/each}
      </ul>
      <div class="hints" aria-label="{state.hints} hints remaining.">
        <Hint /> × {state.hints}
      </div>
      <div class="deck-wrapper">
        <span class="deck">
          <Deck faceDown reverse deck={state.deck} />
        </span>
        × {state.deck.length}
      </div>
    </div>

    <div class="cards-field">
      <h4>Discarded cards</h4>
      <ul class="discarded-piles">
        {#each suits as suit (suit)}
          <li>
            <ul class="discarded-pile">
              <div class="discarded-pile-spot"><EmptyCardSpot /></div>
              {#if discardedCards[suit]}
                {#each discardedCards[suit] as card (card)}
                  <li class="discarded-card">
                    <CardFront {card} />
                  </li>
                {/each}
              {/if}
            </ul>
          </li>
        {/each}
      </ul>
    </div>
  </section>
  {#each players as player, idx (player.id)}
    <div
      class="player"
      style={`
          --player-translate-x: ${(
            Math.cos(Math.PI / 2 + idx * ((2 * Math.PI) / players.length)) *
            22.5
          ).toFixed(3)}em;
          --player-translate-y: ${(
            Math.sin(Math.PI / 2 + idx * ((2 * Math.PI) / players.length)) *
            24.5
          ).toFixed(3)}em;

        `}
    >
      <ul class="cards">
        {#each showCardFaces( { player, user } ) ? reversed(player.hand) : player.hand as { card, rankHint, suitHint }, cardIdx (card)}
          <li
            style={`
                font-size: ${player.id === playerId ? "0.9em" : "0.6em"};
                position: absolute;
                left: 50%;
                bottom: -1rem;
                transform-origin: 50% 300%;
                transform:
                  translateX(-50%)
                  rotate(${6 * (cardIdx - (player.hand.length - 1) / 2)}deg)
                  ${
                    isSpeaking(state, player.id) && player.id !== playerId
                      ? "translateY(-3em)"
                      : ""
                  };
              `}
          >
            {#if showCardFaces({ user, player })}
              <CardFront {card} />
            {:else}
              <button
                class="card-button"
                disabled={playerId === null ||
                  !isActivePlayer(state.phase, playerId) ||
                  (actionMode !== ActionMode.Discarding &&
                    actionMode !== ActionMode.Playing)}
                on:click={() => {
                  switch (actionMode) {
                    case ActionMode.Discarding:
                      return dispatchAction(["Discard", { idx: cardIdx }]);
                    case ActionMode.Playing:
                      return dispatchAction(["Play", { idx: cardIdx }]);
                    case ActionMode.Hinting:
                    case null:
                      return;
                  }
                }}
              >
                <CardBack
                  {card}
                  showHint={user?.id === player.id}
                  {rankHint}
                  {suitHint}
                />
              </button>
            {/if}
          </li>
        {/each}
      </ul>
      <gs6-player-box
        userid={player.id}
        thinking={isActivePlayer(state.phase, player.id)}
        speaking={isSpeaking(state, player.id)}
      >
        {#if state.latest !== null}
          <div slot="speech">
            <LatestAction performedAction={state.latest} />
          </div>
        {/if}
      </gs6-player-box>

      {#if player.id === playerId && isActivePlayer(state.phase, playerId)}
        <div class="actions">
          <Actions
            userId={playerId}
            {state}
            mode={actionMode}
            on:action
            on:changeMode={handleChangeMode}
          />
        </div>
      {/if}
    </div>
  {/each}

  {#if state.phase[0] === "GameComplete"}
    <section class="summary panel border shadow">
      <h2>Game over</h2>

      <div>
        <h3>Final score</h3>
        <p class="final-score">
          {#if state.lives === 0}0{:else}{state.played.length}{/if}
        </p>
      </div>

      <p>
        <small>
          {#if state.played.length === 25}
            A perfect score!
          {:else if state.lives === 0}
            You ran out of lives!
          {:else if state.drewLast !== null}You ran out of cards!{/if}
        </small>
      </p>
    </section>
  {/if}
</main>

<style>
  main {
    height: 100%;
  }
  .center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
  .center.user {
    transform: translate(-50%, -50%) translateY(-5rem);
  }
  .center ul {
    margin: 0;
  }
  .counters {
    display: flex;
    justify-content: space-between;
    flex-wrap: nowrap;
    margin-block-start: 0.5em;
    margin-block-end: 0.5em;
  }
  .counters > * {
    margin-block-start: 0;
    margin-block-end: 0;
    margin-inline-start: 0.5rem;
    margin-inline-end: 0.5rem;
  }
  ul.lives {
    display: flex;
    flex-wrap: nowrap;
    font-size: 1.25em;
  }

  .hints {
    font-weight: 500;
    font-size: 1.25em;
    white-space: nowrap;
  }
  .deck-wrapper {
    font-weight: 500;
    font-size: 1.25em;
    display: flex;
    align-items: center;
    flex-wrap: nowrap;
    white-space: nowrap;
  }
  .deck {
    display: inline-block;
    font-size: 0.15rem;
    margin-inline-start: 0.2rem;
    margin-inline-end: 0.4rem;
    transform: translateY(-0.1rem);
  }
  .cards-field {
    background-color: rgba(0, 0, 0, 0.08);
    padding: 0.5em;
    border-radius: 0.5em;
    max-width: 20em;
  }
  .cards-field > h4 {
    display: inline-block;
    padding: 0.25em 0.5em;
    border-radius: 0.4em;
    color: white;
    background-color: rgba(0, 0, 0, 0.28);
  }

  .played {
    display: grid;
    grid-template-columns: repeat(5, 1fr);
    gap: 0.25rem;
  }
  .played-card {
    position: relative;
    font-size: 0.33em;
    height: 14em;
    width: 10em;
  }
  .played-card-spot {
    position: absolute;
  }
  .discarded-piles {
    font-size: 0.33em;
    display: grid;
    grid-template-columns: repeat(5, 1fr);
    gap: 0.25rem;
  }
  .discarded-pile {
    display: flex;
    flex-direction: column;
    flex-wrap: nowrap;
    position: relative;
    height: 14em;
    width: 10em;
  }
  .discarded-pile-spot {
    position: absolute;
  }
  .discarded-card:not(:first-of-type) {
    margin-top: -10.25em;
  }

  .discarded-card:first-child {
    margin-top: 0;
  }

  .player {
    position: absolute;
    top: 50%;
    left: 50%;

    transform: translate(-50%, -50%)
      translate(var(--player-translate-x), var(--player-translate-y))
      translateY(2.25rem);
  }
  ul.cards {
    position: relative;
  }
  ul.cards > li {
    transition: transform 0.3s;
  }
  .actions {
    position: absolute;
    bottom: calc(100% + 0.75rem);
    left: 50%;
    transform: translateX(-50%);
  }
  .card-button {
    margin: 0;
    border: 0;
    padding: 0;
    font-size: inherit;
    border-radius: 7% / 5%;
    transition: transform 0.2s;
  }
  .card-button:not(:disabled) {
    cursor: pointer;
  }
  .card-button:not(:disabled):hover,
  .card-button:not(:disabled):focus {
    transform: translateY(-2rem);
  }

  .summary {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    display: flex;
    flex-direction: column;
    align-items: center;
    text-align: center;
  }
  .summary .final-score {
    margin: 0;
    font-size: 5rem;
    line-height: 1;
  }
</style>
